Skip to main content
`Ctrl`+`K`

# PCShellSetApplySymmetricLeft

Sets routine to use as left preconditioner (when the `PC_SYMMETRIC` is used).

## Synopsis

    #include "petscpc.h"
    PetscErrorCode PCShellSetApplySymmetricLeft(PC pc, PetscErrorCode (*apply)(PC pc, Vec xin, Vec xout))

Logically Collective

## Input Parameters

- pc - the preconditioner context

- apply - the application-provided left preconditioning routine

## Calling sequence of `apply`

- pc - the preconditioner

- xin - input vector

- xout - output vector

## Note

You can get the `PCSHELL` context set with `PCShellSetContext()` using `PCShellGetContext()` if needed by `apply`.

## See Also

KSP: Linear System Solvers, `PCSHELL`, `PCShellSetApply()`, `PCShellSetSetUp()`, `PCShellSetApplyTranspose()`, `PCShellSetContext()`

## Level

advanced

## Location

src/ksp/pc/impls/shell/shellpc.c

## Implementations

PCShellSetApplySymmetricLeft_Shell(PC pc, PetscErrorCode (*apply)() in src/ksp/pc/impls/shell/shellpc.c

Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages